// Copyright (c) 2016, Shinichiro Abe. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import 'package:ducene/store.dart';
import 'package:test/test.dart';
import 'dart:io';

void main() {
  group('A group of directory', () {
    RAMIndexDirectory ramIndexDirectory;
    FSIndexDirectory fsIndexDirectory;
    Directory dir = new Directory('test-dir');

    setUp(() {
      if (dir.existsSync()) dir.deleteSync(recursive: true);
    });

    tearDown(() {
      if (dir.existsSync()) dir.deleteSync(recursive: true);
    });

    test('test init', () async {
      ramIndexDirectory = new RAMIndexDirectory();
      await ramIndexDirectory.initOutput();
      ramIndexDirectory.initInput();
      fsIndexDirectory = new FSIndexDirectory(dir);
      await fsIndexDirectory.initOutput();
      fsIndexDirectory.initInput();

      expect(ramIndexDirectory.inputIndex(), isNotNull);
      expect(fsIndexDirectory.inputIndex(), isNotNull);
      expect(dir.existsSync(), isTrue);
    });

  });
}

