// Copyright (c) 2016, Shinichiro Abe. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import 'package:ducene/document.dart';
import 'package:ducene/index.dart';
import 'package:ducene/search.dart';
import 'package:ducene/store.dart';
import 'package:test/test.dart';

void main() {
  group('A group of query', () {

    test('test bool op', () async {
      IndexDirectory indexDirectory = new RAMIndexDirectory();
      IndexWriter writer = new IndexWriter(indexDirectory);

      Document doc1 = new Document();
      doc1.append("id", 'xx');
      Document doc2 = new Document();
      doc2.append("id", 'yy');

      await writer.write([doc1, doc2]);

      IndexReader reader = await DirectoryReader.open(indexDirectory);
      IndexSearcher searcher = new IndexSearcher(reader);

      BoolQuery q = new BoolQuery()
          .append('id', 'xx')
          .append('id', 'yy');
      expect(await searcher.count(q), 2);

                q = new BoolQuery(Op.or)
          .append('id', 'xx')
          .append('id', 'yy');
      expect(await searcher.count(q), 2);

                q = new BoolQuery(Op.or)
          .append('id', 'xx')
          .append('id', 'aa');
      expect(await searcher.count(q), 1);

                q = new BoolQuery(Op.and)
          .append('id', 'xx')
          .append('id', 'yy');
      expect(await searcher.count(q), 0);

                q = new BoolQuery(Op.and)
          .append('id', 'xx')
          .append('id', 'aa');
      expect(await searcher.count(q), 0);

                q = new BoolQuery(Op.or)
          .append('id', 'yy');
      expect(await searcher.count(q), 1);

                q = new BoolQuery(Op.and)
          .append('id', 'yy');
      expect(await searcher.count(q), 1);
    });

  });
}

